using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace InfiniTec.DirectoryServices
{

    /// <summary>
    /// This exception is thrown, when an Active Directory object does not contains a required
    /// object class value.
    /// </summary>
    [global::System.Serializable]
    public class InvalidObjectCategoryException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InvalidObjectCategoryException"/> class.
        /// </summary>
        public InvalidObjectCategoryException() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="InvalidObjectCategoryException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        public InvalidObjectCategoryException(string message) : base(message) { }
        /// <summary>
        /// Initializes a new instance of the <see cref="InvalidObjectCategoryException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="inner">The inner exception.</param>
        public InvalidObjectCategoryException(string message, Exception inner) : base(message, inner) { }
        /// <summary>
        /// Initializes a new instance of the <see cref="InvalidObjectCategoryException"/> class.
        /// </summary>
        /// <param name="info">The <see cref="T:System.Runtime.Serialization.SerializationInfo"></see> that holds the serialized object data about the exception being thrown.</param>
        /// <param name="context">The <see cref="T:System.Runtime.Serialization.StreamingContext"></see> that contains contextual information about the source or destination.</param>
        /// <exception cref="T:System.Runtime.Serialization.SerializationException">The class name is null or <see cref="P:System.Exception.HResult"></see> is zero (0). </exception>
        /// <exception cref="T:System.ArgumentNullException">The info parameter is null. </exception>
        protected InvalidObjectCategoryException(
          SerializationInfo info,
          StreamingContext context)
            : base(info, context) { }
    }
}
